> For the complete documentation index, see [llms.txt](https://docs.yuzu.finance/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.yuzu.finance/technical/smart-contracts/yuzu-amm-testnet/router/aggregator-integration.md).

# Aggregator Integration

### Get Amount In

`router::get_amount_in`

#### **Description**

This function calculates the required input amount of token **X** to receive a specific output amount of token **Y**.

#### **Usage**

* **Checks**: Ensures that a pair exists between token **X** and token **Y** before proceeding.
* **Returns**: The amount of token **X** required for the swap.

#### **Parameters**

| Input Value    | Type  | Description                               |
| -------------- | ----- | ----------------------------------------- |
| `y_out_amount` | `u64` | The desired output amount of token **Y**. |

#### **Code**

```move
public fun get_amount_in<X, Y>(y_out_amount: u64): u64 {
    assert!(swap::is_pair_created<X, Y>(), errors::pair_not_created());
    let is_x_to_y = swap_utils::sort_token_type<X, Y>();
    get_amount_in_internal<X, Y>(is_x_to_y, y_out_amount)
}
```

***

### Get Amount Out

`router::get_amount_out`

#### **Description**

This function calculates the output amount of token **Y** given an input amount of token **X**.

#### **Usage**

* **Checks**: Ensures that a pair exists between token **X** and token **Y** before proceeding.
* **Returns**: The amount of token **Y** that will be received for the swap.

#### **Parameters**

| Input Value   | Type  | Description                      |
| ------------- | ----- | -------------------------------- |
| `x_in_amount` | `u64` | The input amount of token **X**. |

#### **Code**

```move
public fun get_amount_out<X, Y>(x_in_amount: u64): u64 {
    assert!(swap::is_pair_created<X, Y>(), errors::pair_not_created());
    let is_x_to_y = swap_utils::sort_token_type<X, Y>();
    get_amount_out_internal<X, Y>(is_x_to_y, x_in_amount)
} 
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.yuzu.finance/technical/smart-contracts/yuzu-amm-testnet/router/aggregator-integration.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
